/*
 * 说明：应用页面
 * 时间：2018/3/14  10：47
 * 创建：ch
 */
var applicationIdx = (function(c, $) {
	var cityName = '', //用户当前城市名
		district = ''; //区
	var ui = {
		weather: document.getElementById("weather"),
	}
	//获取天气
	function getWeather() {
		if(!cityName) {
			cityName = '南京市'
		}
		c.dataUtil.getWeather(cityName, function(res) {
			console.log('===天气信息===' + JSON.stringify(res));
			if(res.SystemCode == 1) { //请求天气成功
				var weatherContent = JSON.parse(res.data.weatherContent);

				if(weatherContent.msg == 'ok') {
					console.log(ui.weather);
					ui.weather.innerHTML = template('weatherTmpl', {
						cityName: cityName,
						district: district,
						weatherContent: weatherContent.result.daily
					})
				} else {
					ui.weather.innerHTML = '<div class="no-weather" >天气正在加载中...</div>'
				}
				//页面数据渲染

			} else {
				$.toast(c.ERROR_CONFIG[res.SystemCode]);
			}
		}, function(xhr, type, err) {
			$.toast('服务器异常，请稍后重试');
		})
	}
	$.ready(function() {
		//自定义登录事件
		c.addEventListener('login', function(e) {
			console.log('===应用页面登录===');
			getWeather();
		})
	})
	//事件绑定
	function bindEvents() {
		//跳转其他功能页面
		$('.m-panel').on('tap', '.u-panel-item', function() {
			if(this.dataset.target) {
				if(this.dataset.target != 'weather')
				c.webviewUtil.show(this.dataset.target);
			} else if(this.dataset.url) {
				c.webviewUtil.show('third_party', null, null, null, {
					url: this.dataset.url,
					text: this.dataset.text
				})
			} else {
				$.toast('敬请期待');
			}
		})
	}

	return {
		init: function() {
			bindEvents();
			plus.geolocation.getCurrentPosition(function(res) {
				console.log('===当前位置===' + JSON.stringify(res));
				if(res.address) { //包含城市名
					cityName = res.address.city;
					district = res.address.district;
				} else {
					cityName = '南京市';
				}
			}, function(e) {
				console.log('定位失败')
				cityName = '南京市';
			}, {
				getcode: false,
				provider: 'system'
			}); //provider待定
		}
	}
}(window, mui));

var application_youth = (function(c, $) {
	//自定义登录事件
	$.ready(function() {
		c.addEventListener('login', function(e) {
			console.log('===凝聚青春应用页面登录===' + plus.webview.currentWebview().id);
		})
	})
	//事件绑定
	function bindEvents() {

		//跳转其他功能页面
		$('.m-panel').on('tap', '.u-panel-item', function() {
			if(this.dataset.target) {
				c.webviewUtil.show(this.dataset.target);
			} else {
				$.toast('敬请期待');
			}
		})
	}

	return {
		init: function() {
			bindEvents();
		}
	}
}(window, mui));