/*
 * 说明：我的中队=>圈子
 * 时间：2018/3/14  10：47
 * 创建：ch
 */
var circleIdx = (function(c, $) {
	var nextUrl = '', //下一页地址
		num = 0, //图片的group基数
		userInfo = null; //用户信息
	var isCanPraise = true;
	var ui = {
		appreciate: document.querySelector(".squadron-appreciate"),
		edit: document.querySelector(".squadron-edit"),
		add: document.getElementById("add"),
		circleList: document.getElementById("circleList"),
	}
	var config = {
		keyEventBind: {
			backbutton: false //取消监听返回键
		},
		pullRefresh: {
			container: '#circleList',
			down: {
				style: 'circle',
				color: '#eb3a3a',
				offset: '45px',
				auto: true,
				callback: function() {
					initPage(true);
				}
			},
			up: {
				contentrefresh: "正在加载...",
				contentnomore: '没有更多数据了',
				callback: function() {
					initPage(false);
				}
			}
		}
	};
	//自定义登录事件
	$.ready(function() {
		c.addEventListener('login', function(e) {
			console.log('===我的中队页面登录===');
			$.init(config)
		});
	})

	//初始化页面数据
	function initPage(isDown) {
		var refreshEl = $('#circleList').pullRefresh();
		if(isDown) {
			c.dataUtil.circleList('', function(res) {
				console.log('===我的中队===' + JSON.stringify(res));
				refreshEl.endPulldown(); //结束下拉刷新
				if(res.SystemCode == 1) {
					nextUrl = res.nextUrl;
					if(nextUrl == '') { //无下一页数据
						refreshEl.disablePullupToRefresh(); //禁用上拉
					} else {
						refreshEl.enablePullupToRefresh(); //启用上拉
						refreshEl.refresh(true); //重置上拉
					}

					if(res.varList) {
						for(var i = 0; i < res.varList.length; i++) {
							if(res.varList[i].attList) {
								res.varList[i].attList = res.varList[i].attList.split(',');
							}
							res.varList[i].praisePeople = '';
							if(res.varList[i].praiseList) {
								for(var j = 0; j < res.varList[i].praiseList.length; j++) {
									if(j == res.varList[i].praiseList.length - 1) {
										res.varList[i].praisePeople += res.varList[i].praiseList[j].userName;
									} else {
										res.varList[i].praisePeople += res.varList[i].praiseList[j].userName + ',';
									}
								}
							}
						}
						//数据渲染
						ui.circleList.innerHTML = template('circleListTmpl', {
							list: res.varList,
							picHost: c.IMAGE_GET_CONFIG,
							num: num
						});
						//绑定点赞事件
						bindPraiseEvent();
					} else {
						ui.circleList.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
					}

				} else {
					refreshEl.disablePullupToRefresh(); //禁用上拉
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}

			}, function(xhr, type, err) {
				$.toast('服务器异常，稍后重试');
			})
		} else {
			if(nextUrl == "") {
				$.toast('没有更多数据了');
				refreshEl.disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.dataUtil.circleList(c.HOST_CONFIG + nextUrl, function(res) {
				console.log('====我的中队上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					nextUrl = res.nextUrl;
					if(nextUrl == "") {
						refreshEl.endPullupToRefresh(true);
					} else {
						refreshEl.endPullupToRefresh(false);
					}
					for(var i = 0; i < res.varList.length; i++) {
						if(res.varList[i].attList) {
							res.varList[i].attList = res.varList[i].attList.split(',');
						}
						res.varList[i].praisePeople = '';
						if(res.varList[i].praiseList) {
							for(var j = 0; j < res.varList[i].praiseList.length; j++) {
								if(j == res.varList[i].praiseList.length - 1) {
									res.varList[i].praisePeople += res.varList[i].praiseList[j].userName;
								} else {
									res.varList[i].praisePeople += res.varList[i].praiseList[j].userName + ',';
								}
							}
						}
					}
					num += 10;
					//数据渲染
					ui.circleList.innerHTML += template('circleListTmpl', {
						list: res.varList,
						picHost: c.IMAGE_GET_CONFIG,
						num: num
					})
					bindPraiseEvent(); //绑定点赞和删除事件
				} else {
					refreshEl.disablePullupToRefresh(); //禁用上拉
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function() {
				$.toast('服务器异常，请稍后重试');
			})
		}
	}

	//事件绑定
	function bindEvents() {
		//跳转新增
		ui.add.addEventListener('tap', function() {
			c.webviewUtil.show('addSquadron', null, null, null, null);
		});

		//自定义事件 => 刷新列表
		window.addEventListener('addSuccess', function(e) {
			initPage(true);
		})

		//评论数点击 => 弃用
		$('.u-handle').on('tap', '.squadron-edit', function() {
			if(this.classList.contains('squadron-edit-active')) {
				var _self = this;
				_self.classList.remove('squadron-edit-active');
				_self.nextElementSibling.innerHTML = Number(_self.nextElementSibling.innerHTML) - 1;
			} else {
				var _self = this;
				_self.classList.add('squadron-edit-active');
				_self.nextElementSibling.innerHTML = Number(_self.nextElementSibling.innerHTML) + 1;
			}
		});

	}

	function bindPraiseEvent() {
		//点赞
		$('.u-handle').on('tap', '.squadron-appreciate', function() {

			var _self = this;
			if(this.classList.contains('squadron-appreciate-active') && isCanPraise) {
				//调取取消点赞的接口
				isCanPraise = false; //避免多次取消点赞
				c.dataUtil.cancelPraise(_self.dataset.id, function(res) {
					console.log('===取消点赞===' + JSON.stringify(res));
					isCanPraise = true;
					if(res.SystemCode == 1) {
						_self.classList.remove('squadron-appreciate-active');
						_self.nextElementSibling.innerHTML = Number(_self.nextElementSibling.innerHTML) - 1;
						var _obj = JSON.parse(_self.dataset.obj);
						var praisePersonArr = _obj.praisePeople.split(',');
						var newArr = [];
						if(praisePersonArr.length <= 1) { //只有当前用户点赞
							_self.parentNode.parentNode.parentNode.querySelector('.u-disscuss-pub').classList.remove('u-disscuss-pub-show');
						} else {
							for(var i = 0; i < praisePersonArr.length; i++) {
								if(userInfo.realName != praisePersonArr[i]) {
									newArr.push(praisePersonArr[i]);
								}
							}
						}

						_self.parentNode.parentNode.parentNode.querySelector('.praisePeople').innerText = newArr.join(',');
					}
				}, function(xhr, type, err) {
					isCanPraise = true;
				})
			} else if(!this.classList.contains('squadron-appreciate-active') && isCanPraise) {
				isCanPraise = false; //避免多次点赞
				//此处应该调取点赞接口
				c.dataUtil.praiseCircleItem(_self.dataset.id, function(res) {
					console.log('===点赞圈子===' + JSON.stringify(res));
					isCanPraise = true;
					if(res.SystemCode == 1) {
						_self.classList.add('squadron-appreciate-active');
						_self.nextElementSibling.innerHTML = Number(_self.nextElementSibling.innerHTML) + 1;
						var txt = _self.parentNode.parentNode.parentNode.querySelector('.praisePeople').innerText;
						if(!_self.parentNode.parentNode.parentNode.querySelector('.u-disscuss-pub').classList.contains('u-disscuss-pub-show')) { //如果当前没有点赞的人
							_self.parentNode.parentNode.parentNode.querySelector('.u-disscuss-pub').classList.add('u-disscuss-pub-show');
							_self.parentNode.parentNode.parentNode.querySelector('.praisePeople').innerText = userInfo.realName;
						} else {
							_self.parentNode.parentNode.parentNode.querySelector('.praisePeople').innerText = txt + ',' + userInfo.realName;
						}
					}
				}, function(xhr, type, err) {
					isCanPraise = true;
				})
			}
		});

		$('.publish-info').on('tap', '.del', function() {
			var _self = this;
			$.confirm('是否确认删除该记录', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					c.dataUtil.delCircleItem(_self.dataset.id, function(res) {
						console.log('===删除圈子===' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							$.toast('删除成功');
							_self.parentNode.parentNode.parentNode.parentNode.parentNode.remove();
						} else {
							$.toast('删除失败');
						}
					}, function(xhr, type, err) {
						$.toast('删除失败，请稍后重试');
					})
				}
			})
		})

	}

	return {
		init: function() {
			bindEvents();
			userInfo = JSON.parse(plus.storage.getItem('userInfo'));
			console.log('===用户信息===' + JSON.stringify(userInfo));
		},
		initPage: initPage
	}
}(window, mui));

/*
 * 说明：新增校园圈
 * 时间：2018/4/4 16:00
 * 创建： ch
 */

var addCircle = (function(c, $) {

	var ui = {
			addCirclePhotoBtn: document.getElementById("addCirclePhotoBtn"),
			done: document.getElementById("done"),
			txt: document.getElementById("circle-text"),
		},
		selectedPicNum = 0; //已经选择的图片数

	//事件绑定 
	function bindEvents() {

		//点击上传图片
		ui.addCirclePhotoBtn.addEventListener('tap', function() {
			if(selectedPicNum == 9) {
				plus.nativeUI.toast('最多只能选取9张图片');
				return;
			}
			plus.nativeUI.actionSheet({
				cancel: "取消",
				buttons: [{
					title: "从相册选择"
				}, {
					title: "拍照"
				}]
			}, function(sheetEvent) { // 谈出框选择后回调
				if(sheetEvent.index == 1) { //从相册选择
					plus.gallery.pick(function(gEvent) {
						for(var i = 0; i < gEvent.files.length; i++) {
							var dst = "_downloads/camera/" + gEvent.files[i].substring(gEvent.files[i].lastIndexOf('/'));
							c.methodUtil.compressImage(gEvent.files[i], dst, function(zipEvent) {
								var newNode = document.createElement("li");
								newNode.innerHTML = '<img class="icon-remove" src="../../assets/images/squadron/cancel.png" /><img class="circle-photo-item" src="' +
									zipEvent.target + '"/>';

								document.getElementById('publishPhotoList').insertBefore(newNode, ui.addCirclePhotoBtn);
								selectedPicNum++;
							}, function() {
								plus.nativeUI.toast("操作失败");
								return;
							}, 20)
						}

					}, function() {
						return;
					}, {
						filter: 'image',
						multiple: true,
						maximum: (9 - selectedPicNum),
						system: false,
						onmaxed: function() {
							if(selectedPicNum == 0) {
								plus.nativeUI.toast('最多只能选取9张图片');
							} else {
								plus.nativeUI.toast('已有' + selectedPicNum + '张图片待上传，最多只能选取' + (9 - selectedPicNum) + '张图片');
							}
						}
					});

				} else if(sheetEvent.index == 2) { //拍照
					c.methodUtil.getCamera(function(path) {
						c.methodUtil.compressImage(path, "_downloads/camera/" + path.substring(path.lastIndexOf('/')), function(zipEvent) {
							var newNode = document.createElement("li");
							newNode.innerHTML = '<img class="icon-remove" src="../../assets/images/squadron/cancel.png" /><img class="circle-photo-item" src="' +
								zipEvent.target + '"/>';
							document.getElementById('publishPhotoList').insertBefore(newNode, ui.addCirclePhotoBtn);
							selectedPicNum++;
						}, function() {
							plus.nativeUI.closeWaiting();
							plus.nativeUI.toast("操作失败");
							return;
						}, 20)
					});
				}
			});
		});

		//删除图片
		$("#publishPhotoList").on('tap', '.icon-remove', function() {
			this.parentNode.remove();
			selectedPicNum--;
		});

		//发表中队圈
		ui.done.addEventListener('tap', function() {
			var txtVal = ui.txt.value;
			if(txtVal == "" && selectedPicNum == 0) {
				$.toast("请输入内容或添加图片");
				return;
			} else if(!c.methodUtil.filterEmoji(txtVal)) { //有emoji表情
				return;
			} else if(txtVal.length > 500) {
				$.toast("圈子内容不能超过500字");
				return;
			}
			//验证通过
			$.confirm('是否确认发布', '提示', ['确认', '取消'], function(e) {
				document.activeElement.blur(); //收回软键盘
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.nativeUI.showWaiting('发布中...');
					var photos = []; //上传图片地址
					var photosPath = []; //返回图片地址
					$('.circle-photo-item').each(function() {
						photos.push(this.getAttribute('src'));
					});
					var i = 0;
					var length = photos.length;
					//递归上传图片
					var loop = function(i, callBack) {
						if(i < length) {
							c.methodUtil.uploadImage(photos[i], function(res) {

								photosPath.push(res.data[0]);
								console.log(JSON.stringify(res))
								i++;
								loop(i, callBack);
							});
						} else {
							callBack();
						}
					};
					loop(i, function() {
						var paths = photosPath.length > 0 ? photosPath.toString() : ""; //图片路径
						console.log(JSON.stringify(photosPath))
						if(paths) { //有图片
							var sendObj = {
								content: ui.txt.value,
								circleType: '2',
								attList: paths
							} //传给后台的参数
						} else {
							var sendObj = {
								content: ui.txt.value,
								circleType: '2',
							} //传给后台的参数
						}
						//调取后端新增接口
						c.dataUtil.addSquadron(sendObj, function(res) {
							plus.nativeUI.closeWaiting();
							console.log('===新增圈子===' + JSON.stringify(res));
							if(res.SystemCode == 1) {
								$.toast('提交成功');
								//触发自定义事件
								$.fire(plus.webview.currentWebview().opener(), 'addSuccess', {});
								setTimeout(function() {
									plus.webview.currentWebview().close(); //关闭页面
								})
							} else {
								$.toast(c.ERROR_CONFIG[res.SystemCode]);
							}
						}, function(xhr, type, err) {
							plus.nativeUI.closeWaiting();
							$.toast('提交失败，请稍后重试')
						})
					});
				}
			})

		})

	}

	return {
		init: function() {
			bindEvents();
		}
	}
}(window, mui));