/*
 * 说明：主页面预加载逻辑
 * 
 */
var Main = (function(c, $) {
	var refreshTokenTimer = null; //token定时器

	//设置token刷新定时器
	function setTokenRefreshTimer() {
		refreshTokenTimer = refreshTokenTimer ? window.clearInterval(refreshTokenTimer) : null; // 若定时器已存在，先清空
		refreshTokenTimer = setInterval(function() {
			c.dataUtil.tokenExchange(function(res) {
				console.log('旧换新' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					var userInfo;
					if(plus.storage.getItem('userInfo')) {
						userInfo = JSON.parse(plus.storage.getItem('userInfo'))
					} else {
						userInfo = {};
					}
					userInfo.token = res.token;
					plus.storage.setItem('userInfo', JSON.stringify(userInfo));
				} else {
					c.webviewUtil.show('login', null, null, null, null)
				}
			}, function(xhr, type, err) {
				console.log('====' + xhr.status)
			});
		}, 13800000);
	}

	//事件绑定
	function bindEvents() {
		setTokenRefreshTimer();
		//重置定时器
		c.addEventListener('resetTokenTimer', function() {
			setTokenRefreshTimer();
		});

		// 自定义事件——清除定时器c
		c.addEventListener('destroyTokenTimer', function() {
			refreshTokenTimer = refreshTokenTimer ? c.clearInterval(refreshTokenTimer) : null;
		});

	}

	return {
		init: function() {
			document.activeElement.blur(); //关闭软键盘
			var views = [];//子页面数组

			var userCode = c.methodUtil.getRole();
			//加载主页面子页面
//			if(userCode == '0') { //少先队角色
//				console.log('少先队')
//				views = [
//					VIEW_CONFIG['appPanel'],
//					VIEW_CONFIG['youthApplicationIdx'],
//					VIEW_CONFIG['squadronIdx'],
//					VIEW_CONFIG['rosterIdx'],
//					VIEW_CONFIG['messageIdx'],
//					VIEW_CONFIG['mineIdx'],
//					VIEW_CONFIG['mainIdx']
//				]
//			} else { //凝聚青春角色
				console.log('凝聚')
				views = [
//					VIEW_CONFIG['appPanel'],
//					VIEW_CONFIG['squadronIdx'],
//					VIEW_CONFIG['rosterIdx'],
					VIEW_CONFIG['messageIdx'],
					VIEW_CONFIG['mineIdx'],
					VIEW_CONFIG['mainIdx'],
					VIEW_CONFIG['youthApplicationIdx'],
				]
//			}
			c.webviewUtil.create(views, 'main');
			bindEvents();
			if(plus.webview.currentWebview().isChang) {
				var views = ['mainIdx', /*'appPanel', 'squadronIdx', */'youthApplicationIdx', 'mineIdx',  'messageIdx'];
				views.forEach(function(e) {
					setTimeout(function() {
						$.fire(plus.webview.getWebviewById(e), 'login', {});
					}, 300)
				});
			}

		}
	}
})(window, mui);

/*
 * 说明：首页逻辑
 * 创建：2018-3-10
 * 创建人：ch
 */
var MainIndex = (function(c, $) {

	var url = {
		recommendNextUrl: '', //推荐页下一页地址
		newsNextUrl: '', //新闻页下一页地址
		activityNextUrl: '', //活动页下一页地址 
		articleNextUrl: '', //文章页下一页地址
		trainNextUrl: '', //培训页下一页地址
		forumNextUrl: '', //论坛页下一页地址
	}
	var ui = {
		toAcitivity: document.getElementById("toAcitivity"),
		toAnnouncement: document.getElementById("toAnnouncement"),
		train: document.getElementById("train"),
		trainList: document.getElementById("trainList"),
		activityList: document.getElementById("activityList"),
		newsList: document.getElementById("newsList"),
		articleList: document.getElementById("articleList"),
		recommendList: document.getElementById("recommendList")
	}
	//更新数据=> 目的是同一个方法更新不同的数据
	function updateData(type, isDown) {
		switch(type) {
			case 'recommend': //获取推荐
				//调用加载推荐的方法
				updateRecommendList(isDown);
				break;
			case 'news': //新闻
				//调用加载新闻的方法
				updateNewsList(isDown);
				break;
			case 'activity': //活动
				//调用加载活动的方法
				updateActivityList(isDown);
				break;
			case 'article': //文章
				//调用加载文章的方法
				updateArticleList(isDown);
				break;
			case 'train': //培训
				//调用加载培训的方法
				updateTrainList(isDown);
				break;
			case 'forum': //新闻
				//调用加载论坛的方法
				//updateForumList(isDown);
				break;
			default:
				updateRecommendList(isDown);
				updateNewsList(isDown);
				updateActivityList(isDown);
				updateArticleList(isDown);
				updateTrainList(isDown);
				//updateForumList(isDown);
				break;
		}
	}

	//更新推荐列表的数据
	function updateRecommendList(isDown) {
		var pullRefresh = $('#recommend').pullToRefresh();
		if(isDown) { //下拉刷新
			c.dataUtil.getListRecommend('', function(res) {
				console.log('===推荐下拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.recommendNextUrl = res.nextUrl; //下一页
					if(url.recommendNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					if(res.varList) {
						ui.recommendList.innerHTML = template('recommendListTmpl', {
							list: res.varList,
							picHost: c.IMAGE_GET_CONFIG
						})
					} else {
						ui.recommendList.innerHTML = '<div class="no-data" style="margin-top: 60px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
						ui.recommendList.parentNode.querySelector('.mui-pull-bottom-tips').style.display = 'none';
					}

				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		} else { //上拉加载
			if(url.recommendNextUrl == '') { //无下一页数据
				pullRefresh.endPullUpToRefresh(true);
				return;
			}
			c.dataUtil.getListRecommend(c.HOST_CONFIG + url.recommendNextUrl, function(res) {
				console.log('===推荐上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.recommendNextUrl = res.nextUrl; //下一页
					if(url.recommendNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					ui.recommendList.innerHTML += template('recommendListTmpl', {
						list: res.varList,
						picHost: c.IMAGE_GET_CONFIG
					})
				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				console.log(c.HOST_CONFIG + url.recommendNextUrl)
				console.log(JSON.stringify(xhr.status))
//				$.toast('服务器异常，请稍后重试2')
			})
		}
	}
	//更新新闻列表的数据
	function updateNewsList(isDown) {
		var pullRefresh = $('#news').pullToRefresh();
		if(isDown) { //下拉刷新
			c.dataUtil.getNewsList('', function(res) {
				console.log('===新闻下拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.newsNextUrl = res.nextUrl; //下一页
					if(url.newsNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					if(res.varList) {
						ui.newsList.innerHTML = template('newsListTmpl', {
							list: res.varList,
							picHost: c.IMAGE_GET_CONFIG
						})
					} else {
						ui.newsList.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
						ui.newsList.parentNode.querySelector('.mui-pull-bottom-tips').style.display = 'none';
					}

				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		} else { //上拉加载
			if(url.newsNextUrl == '') { //无下一页数据
				pullRefresh.endPullUpToRefresh(true);
				return;
			}
			c.dataUtil.getNewsList(c.HOST_CONFIG + url.newsNextUrl, function(res) {
				console.log('===新闻上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.newsNextUrl = res.nextUrl; //下一页
					if(url.newsNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					ui.newsList.innerHTML += template('newsListTmpl', {
						list: res.varList,
						picHost: c.IMAGE_GET_CONFIG
					})
				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		}

	}
	//更新活动列表的数据
	function updateActivityList(isDown) {
		var pullRefresh = $('#activity').pullToRefresh();
		if(isDown) { //下拉刷新
			c.dataUtil.getActivityList('', function(res) {
				console.log('===活动列表下拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.activityNextUrl = res.data.nextUrl; //下一页
					if(url.activityNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					if(res.data.varList) {
						ui.activityList.innerHTML = template('trainListTmpl', {
							list: res.data.varList,
							picHost: c.IMAGE_GET_CONFIG
						})
					} else { //没有记录
						ui.activityList.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
						ui.activityList.parentNode.querySelector('.mui-pull-bottom-tips').style.display = 'none';
					}
				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		} else { //上拉加载
			if(url.activityNextUrl == '') { //无下一页数据
				pullRefresh.endPullUpToRefresh(true);
				return;
			}
			c.dataUtil.getActivityList(c.HOST_CONFIG + url.activityNextUrl, function(res) {
				console.log('===活动列表上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.activityNextUrl = res.data.nextUrl; //下一页
					if(url.activityNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.endPullUpToRefresh(false);
					}
					ui.activityList.innerHTML += template('activityListTmpl', {
						list: res.data.varList,
						picHost: c.IMAGE_GET_CONFIG
					})
				} else {
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		}
	}
	//更新文章列表的数据
	function updateArticleList(isDown) {
		var pullRefresh = $('#article').pullToRefresh();
		if(isDown) { //下拉刷新
			c.dataUtil.getArticleList('', function(res) {
				console.log('===文章下拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.articleNextUrl = res.nextUrl; //下一页
					if(url.articleNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					if(res.varList) {
						ui.articleList.innerHTML = template('articleListTmpl', {
							list: res.varList,
							picHost: c.IMAGE_GET_CONFIG
						})
					} else {
						ui.articleList.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
						ui.articleList.parentNode.querySelector('.mui-pull-bottom-tips').style.display = 'none';
					}

				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		} else { //上拉加载
			if(url.articleNextUrl == '') { //无下一页数据
				pullRefresh.endPullUpToRefresh(true);
				return;
			}
			c.dataUtil.getArticleList(c.HOST_CONFIG + url.articleNextUrl, function(res) {
				console.log('===文章上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.articleNextUrl = res.nextUrl; //下一页
					if(url.articleNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					ui.articleList.innerHTML += template('articleListTmpl', {
						list: res.varList,
						picHost: c.IMAGE_GET_CONFIG
					})
				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		}
	}
	//更新培训列表的数据
	function updateTrainList(isDown) {
		var pullRefresh = $('#train').pullToRefresh();
		if(isDown) { //下拉刷新
			c.dataUtil.getTrainList('', function(res) {
				console.log('===培训列表下拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.trainNextUrl = res.data.nextUrl; //下一页
					if(url.trainNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.refresh(true);
						pullRefresh.endPullUpToRefresh(false);
					}
					if(res.data.varList) {
						ui.trainList.innerHTML = template('trainListTmpl', {
							list: res.data.varList,
							picHost: c.IMAGE_GET_CONFIG
						})
					} else { //没有记录
						ui.trainList.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
						ui.trainList.parentNode.querySelector('.mui-pull-bottom-tips').style.display = 'none';
					}

				} else {
					pullRefresh.endPullUpToRefresh(true);
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		} else { //上拉加载
			if(url.trainNextUrl == '') { //无下一页数据
				pullRefresh.endPullUpToRefresh(true);
				return;
			}
			c.dataUtil.getTrainList(c.HOST_CONFIG + url.trainNextUrl, function(res) {
				console.log('===培训列表上拉===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					url.trainNextUrl = res.data.nextUrl; //下一页
					if(url.trainNextUrl == '') {
						pullRefresh.endPullUpToRefresh(true);
					} else {
						pullRefresh.endPullUpToRefresh(false);
					}
					ui.trainList.innerHTML += template('trainListTmpl', {
						list: res.data.varList,
						picHost: c.IMAGE_GET_CONFIG
					})
				} else {
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试')
			})
		}
	}
	//更新论坛列表的数据
	function updateForumList(isDown) {
		var pullRefresh = $('#forum').pullToRefresh();
		console.log('论坛' + JSON.stringify(pullRefresh));
		if(isDown) { //下拉刷新
			console.log('论坛下拉')
		} else { //上拉加载
			console.log('论坛上拉')
		}
	}

	//微信分享
	function shareMessage(share, ex) {
		var msg = {
			extra: {
				scene: ex
			}
		};
		msg.href = "http://www.baidu.com/";
		msg.title = "分享测试";
		msg.content = "分享测试内容";
		if(~share.id.indexOf('weibo')) {
			msg.content += "；体验地址：http://www.dcloud.io/hellomui/";
		}
		msg.thumbs = ["http://192.168.241.48:9000/get-image/1000?renditions=fill-50x50"];
		share.send(msg, function() {
			console.log("分享到\"" + share.description + "\"成功！ ");
		}, function(e) {
			console.log("分享到\"" + share.description + "\"失败: " + e.code + " - " + e.message);
		});
	}
	//事件绑定
	function bindEvents() {

		//点击公告按钮
		ui.toAnnouncement.addEventListener('tap', function() {
			//跳转公告列表页
			c.webviewUtil.show('annoucementDetatil', null, null, null, null);
			//			//分享测试
			//			var shares = {};
			//			plus.share.getServices(function(s) {
			//				console.log('===分享服务===' + JSON.stringify(s));
			//				if (s && s.length > 0) {
			//					for (var i = 0; i < s.length; i++) {
			//						var t = s[i];
			//						shares[t.id] = t;
			//					}
			//				}
			//			}, function() {
			//				alert("获取分享服务列表失败");
			//			});
			//			var ids = [{
			//					id: "weixin",
			//					ex: "WXSceneSession"
			//				}, {
			//					id: "weixin",
			//					ex: "WXSceneTimeline"
			//				}],
			//				bts = [{
			//					title: "发送给微信好友"
			//				}, {
			//					title: "分享到微信朋友圈"
			//				}];
			//			plus.nativeUI.actionSheet({
			//				cancel: "取消",
			//				buttons: bts
			//			}, function(e) {
			//				var i = e.index;
			//				if(i > 0) {
			//					var s_id = ids[i - 1].id;
			//					var share = shares[s_id];
			//					if(share.authenticated) {
			//						shareMessage(share, ids[i - 1].ex);
			//					} else {
			//						share.authorize(function() {
			//							shareMessage(share, ids[i - 1].ex);
			//						}, function(e) {
			//							console.log("认证授权失败：" + e.code + " - " + e.message);
			//						});
			//					}
			//				}
			//			});
		})
		
		
		//跳转最新活动
		ui.toAcitivity.addEventListener('tap', function() {
			c.webviewUtil.show('activityIdx', null, null, null, null);
		})

		//点击跳转详情
		$('.m-list').on('tap', 'li', function() {
			if(this.dataset.target) {
				c.webviewUtil.show(this.dataset.target, null, null, null, {
					pageId: this.dataset.pageId
				});
			}
		})
	}
	
	$.ready(function() {
		//自定义登录事件
		c.addEventListener('login', function(e) {
			console.log('===主页面登录===');
			updateData('all', true);
		})
		//循环初始化所有下拉刷新，上拉加载。
		$.each(document.querySelectorAll('.mui-slider-group .mui-scroll'), function(index, pullRefreshEl) {
			var freshType = pullRefreshEl.dataset.type;
			$(pullRefreshEl).pullToRefresh({
				down: {
					callback: function() {
						var self = this;
						setTimeout(function() {
							var ul = self.element.querySelector('.mui-table-view');
							updateData(freshType, true);
							self.endPullDownToRefresh();
						}, 500);
					}
				},
				up: {
					callback: function() {
						var self = this;
						setTimeout(function() {
							var ul = self.element.querySelector('.mui-table-view');
							updateData(freshType, false);
//							self.endPullUpToRefresh();
						}, 500);
					}
				}
			});
		});

	});
	//首页的块状导航的点击事件
	function tapHandler() {
		$('.m-button f-clearfix').on('tap', '.m-button-item', function() {
			c.webviewUtil.show(this.dataset.target);
		});
	}
	return {
		init: function() {
			tapHandler();
			bindEvents();
		}
	}
}(window, mui));