/*
 * 说明：我的
 * 时间：2018/3/14  10：47
 * 创建：ch
 */
var mineIdx = (function(c, $) {
	var ui = {
		headImage: document.getElementById("headImage"),
		name: document.getElementById("name"),
		//		org:document.getElementById("org")
	}

	//事件绑定
	function bindEvents() {
		//自定义事件 => 更新用户头像
		window.addEventListener('cutsrc', function(event) {
			ui.headImage.src = c.IMAGE_GET_CONFIG + event.detail.photoId;
			var userData = JSON.parse(plus.storage.getItem('userInfo'))
			userData.portrait = event.detail.photoId;
			userData.photo = event.detail.photoId;
			plus.storage.setItem('userInfo', JSON.stringify(userData));
		});
		
		//自定义事件 => 提交修改资料后
		window.addEventListener('afterModify', function(e) {
			var userData = JSON.parse(plus.storage.getItem('userInfo'))
			userData.nickName = event.detail.nickName;
			plus.storage.setItem('userInfo', JSON.stringify(userData));
			ui.name.innerText = e.detail.nickName;
		})
		
		//点击跳转二级页面
		$('.user-management').on('tap', 'li', function() {
			if(this.dataset.target) {
				c.webviewUtil.show(this.dataset.target, null, null, null, null);
			}
		})

		//点击上传头像 
		ui.headImage.addEventListener('tap', function() {
			plus.nativeUI.actionSheet({
				cancel: "取消",
				buttons: [{
					title: "从相册选择"
				}, {
					title: "拍照"
				}]
			}, function(e) {
				switch(e.index) {
					case 1:
						//从相册选择
						c.webviewUtil.show('cutImg', null, null, null, {
							//							path:path
						});
						plus.gallery.pick(function(path) {
							var cutImg = plus.webview.getWebviewById('cutImg');
							if(path) {
								$.fire(cutImg, 'path', {
									path: path
								});
							}
						}, function(e) {
							plus.webview.getWebviewById('cutImg').close();
						}, {
							filter: 'image'
						});
						break;
					case 2:
						//拍照
						webviewUtil.show('cutImg', null, null, null, {
							//								path:path
						});
						var cmr = plus.camera.getCamera();
						cmr.captureImage(function(path) {
							var cutImg = plus.webview.getWebviewById('cutImg');
							$.fire(cutImg, 'path', {
								path: path
							});
						}, function(e) {
							plus.webview.getWebviewById('cutImg').close();
							console.log(e.message);
						})
						break;
				}
			});
		})
	}

	$.ready(function() {
		c.addEventListener('login', function(e) {
			console.log('===我的页面登录===');
			var userInfo = JSON.parse(plus.storage.getItem('userInfo'));
			ui.name.innerText = userInfo.nickName || userInfo.realName || userInfo.userName;
			ui.headImage.src = c.IMAGE_GET_CONFIG + userInfo.photo || c.IMAGE_GET_CONFIG + userInfo.portrait;
		})
	})
	return {
		init: function() {
			bindEvents();
		}
	}
}(window, mui));
/*
 * 说明：设置
 * 时间：2018/3/14  10：47
 * 创建：ch
 */
var settings = (function(c, $) {
	var ui = {
		quit: document.getElementById("quit"),
		gSwitch: document.getElementById("switch"),
		modifyPwd: document.getElementById("modifyPwd"),
	}

	//事件绑定
	function bindEvents() {
		//退出登录操作
		ui.quit.addEventListener('tap', function() {
			plus.storage.removeItem('userInfo');
			plus.runtime.restart();
		})

		//自定义事件 => 设置手势成功
		c.addEventListener('setGestureSuccess', function(e) {
			ui.gSwitch.classList.add('mui-active');
		})

		//手势密码开关的操作
		ui.gSwitch.addEventListener('toggle', function(e) {
			if(e.detail.isActive) { //启动开关应该跳转手势设置的页面
				ui.gSwitch.classList.remove('mui-active');
				ui.gSwitch.querySelector('.mui-switch-handle').setAttribute('style', '');
				c.webviewUtil.show('resetGesture', null, null, null, null);
			} else { //关闭开关应该调取后端的删除手势的接口
				ui.gSwitch.classList.add('mui-active');
				c.dataUtil.closeGpassword(function(res) {
					console.log('===清空手势密码===' + JSON.stringify(res));
					if(res.SystemCode == 1) {
						ui.gSwitch.classList.remove('mui-active');
						ui.gSwitch.querySelector('.mui-switch-handle').setAttribute('style', '');
						var userInfo = JSON.parse(plus.storage.getItem('userInfo'));
						plus.storage.setItem('useGestureLogin', userInfo.userName + '-false');
					} else {
						$.toast('关闭失败')
					}
				}, function(xhr, type, err) {
					$.toast('关闭失败')
				})
			}
		})

		//修改密码跳转
		ui.modifyPwd.addEventListener('tap', function() {
			c.webviewUtil.show('modifyPwd', null, null, null, null);
		})

	}
	return {
		init: function() {
			plus.nativeUI.showWaiting('加载中...');
			bindEvents();
			var useGestureLogin = plus.storage.getItem('useGestureLogin');
			if(useGestureLogin && useGestureLogin.split('-')[1] == 'true') {
				ui.gSwitch.classList.add('mui-active');
			}
			setTimeout(function() {
				document.querySelector('.g-setting').style.display = 'block';
				plus.nativeUI.closeWaiting();
			}, 300)
		}
	}
}(window, mui));

/*
 * 说明：手势重置密码
 * 时间：2018/2/21 8:56
 * 创建：ch
 */
var ModifyGesture = (function(c, $) {
	var encrypt = new JSEncrypt(); //初始化字符串加密对象
	encrypt.setPublicKey(c.GLOBAL_CONFIG.publicKey); //设置公钥
	var isSetGesture = null; //预留修改手势的标识 
	var ui = {
		title: document.getElementById("title"),
		tips: document.getElementById("tip"),
		holder: document.getElementById("holder"),
	}
	var record = []; //存贮手势密码
	/* 事件绑定 */
	function bindEvents() {
		/* 手势密码事件处理 */

		holder.addEventListener('done', function(e) {
			var rs = e.detail;
			if(rs.points.length < 4) {

				if(record.length == 1) { //第二次
					//					rs.sender.clear();
					//					return;
				} else { //第一次
					ui.tips.innerText = '设定的手势太简单了';
					record = [];
					rs.sender.clear();
					return;
				}
			}
			record.push(rs.points.join(''));
			if(record.length >= 2) {
				if(record[0] == record[1]) {
					plus.nativeUI.showWaiting('设定手势中...');
					var userInfo = JSON.parse(plus.storage.getItem('userInfo')), //缓存中的用户信息
						userName = userInfo.userName; //用户名

					//Ajax请求修改手势密码
					c.dataUtil.updatePassword(userName, '', '', encrypt.encrypt(record[1]), function(res) { //success
							console.log('===修改手势密码===' + JSON.stringify(res));
							plus.nativeUI.closeWaiting();
							if(res.SystemCode === 1) { //手势设定成功
								//更新缓存的用户信息
								userInfo.hasgPassWord = 1;
								plus.storage.setItem('userInfo', JSON.stringify(userInfo));
								//更新手势登录状态
								plus.storage.setItem('useGestureLogin', userInfo.userName + '-true');
								$.fire(plus.webview.currentWebview().opener(), 'setGestureSuccess', {}); //触发控制修改密码部分的显示的自定义事件
								plus.webview.currentWebview().close();
								$.toast('手势密码设置成功');
							} else if(res.SystemCode === 0) {
								ui.tips.innerText = '请重新设定';
								$.toast('后台异常');
								rs.sender.clear();
								record = [];
								return;
							} else {
								$.toast(c.ERROR_CONFIG[res.SystemCode]);
								ui.tips.innerText = '请重新设定';
								rs.sender.clear();
								record = [];
								return;
							}
						},
						function() { //error
							plus.nativeUI.closeWaiting();
							ui.tips.innerText = '请重新设定';
							$.toast('服务器异常，请稍后重试！');
						});
				} else {
					ui.tips.innerText = '两次手势设定不一致';
				}
				rs.sender.clear();
				record = [];
			} else {
				ui.tips.innerText = '请确认手势设定';
				rs.sender.clear();
			}
		})

		/* 手势密码事件处理 end */
	}

	return {
		init: function() {
			bindEvents();
		}
	}
})(window, mui);

/*
 * 说明：修改文本密码
 * 时间：2018/3/21 11:48
 * 创建：ch
 */
var modifyPassword = (function(c, $) {
	var encrypt = new JSEncrypt(); //初始化字符串加密对象
	encrypt.setPublicKey(c.GLOBAL_CONFIG.publicKey); //设置公钥
	var ui = {
		done: document.getElementById("done"),
		oldPwd: document.getElementById("oldPwd"),
		newPwd: document.getElementById("newPwd"),
		newConfirm: document.getElementById("newConfirm"),
	}
	//事件绑定
	function bindEvents() {

		//完成提交
		ui.done.addEventListener('tap', function() {
			document.activeElement.blur(); //收起软键盘
			if(isValid(ui.oldPwd.value.trim(), ui.newPwd.value.trim(), ui.newConfirm.value.trim())) {

				var userName = JSON.parse(plus.storage.getItem('userInfo')).userName;
				plus.nativeUI.showWaiting('提交中...');
				c.dataUtil.updatePassword(userName, encrypt.encrypt(ui.oldPwd.value.trim()), encrypt.encrypt(ui.newPwd.value.trim()), '',
					function(res) {
						plus.nativeUI.closeWaiting();
						console.log('===修改文本密码===' + JSON.stringify(res));
						if(res.SystemCode == 1) { //修改成功
							$.toast('修改成功，请牢记您的新密码');
							plus.webview.currentWebview().close();
						} else if(res.SystemCode == 1004) { //
							$.toast('原密码错误，修改失败');
							return;
						}
					},
					function(xhr, type, err) {
						plus.nativeUI.closeWaiting();
						$.toast('服务器异常，请稍后重试');
						return;
					})
			}
		})
	}
	//验证表单的合法性
	function isValid(oldPwd, newPwd, newConfirm) {
		if(!oldPwd || oldPwd.length == 0 || oldPwd == '') {
			$.toast('请输入原密码');
			return false;
		}
		if(!newPwd || newPwd.length == 0 || newPwd == '') {
			$.toast('请输入新密码');
			return false;
		}
		if(!newConfirm || newConfirm.length == 0 || newConfirm == '') {
			$.toast('请输入确认密码');
			return false;
		}
		if(!/^[a-zA-Z0-9]+$/.test(newConfirm) || !/^[a-zA-Z0-9]+$/.test(oldPwd)) {
			$.toast('密码不能含有特殊字符')
		}
		if(newPwd.length < 6 || newPwd.length > 18 || newConfirm.length < 6 || newConfirm.length > 18) {
			$.toast('密码的长度是6~18位');
			return false
		}
		if(newConfirm !== newPwd) {
			$.toast('两次密码不一致');
			return false;
		}
		return true
	}

	return {
		init: function() {
			bindEvents();
		}
	}
}(window, mui));

/*
 * 说明：我的评论
 * 时间：2018/4/4/ 09:05
 * 创建：lj
 */
var commentList = (function(c, $) {
	//	alert(111);
	var nextUrl = ""; //下一页
	var ui = {
		commentContent: document.getElementById("commentContent"),
	}
	//获取评论列表
	function getCommentList(isRefresh) {
		var refreshBlock = $('#clistBlock').pullRefresh();
		if(isRefresh) { //下拉刷新
			c.dataUtil.getListData('', function(res) {
				console.log('【===评论列表===】' + JSON.stringify(res));
				refreshBlock.endPulldown(); //结束下拉	
				if(res.SystemCode == 1) { //请求成功
					nextUrl = res.nextUrl;
					if(res.varList) {
						for(var i = 0; i < res.varList.length; i++) {
							res.varList[i].timeStamp = res.varList[i].createDate; //创建第二个时间戳变量，便于区分第一个变量进行操作
							//创建一个时间对象 
							var newDate = new Date(res.varList[i].createDate.replace(/-/g, "/")); //兼容ios
							var month = newDate.getMonth() + 1 + '月';
							var date = newDate.getDate() + '日';
							res.varList[i].createDate = [month, date].join(' ');
						}
						//数据渲染
						ui.commentContent.innerHTML = template('commentContentTmpl', {
							List: res.varList,
						});
					} else {
						ui.commentContent.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
					}

					if(nextUrl == '') { //无下一页数据
						refreshBlock.disablePullupToRefresh(); //禁用上拉
					} else {
						refreshBlock.enablePullupToRefresh(); //启用上拉
						refreshBlock.refresh(true); //重置上拉
					}
				} else {
					$.toast(ERROR_CONFIG[res.SystemCode]);
					refreshBlock.disablePullupToRefresh(); //禁用上拉
					return;
				}
			}, function(xhr, type, err) { //error
				console.log(JSON.stringify(err));
				console.log(JSON.stringify(xhr.status));
				refreshBlock.endPulldown(); //结束下拉
				refreshBlock.disablePullupToRefresh(); //禁用上拉
				$.toast('服务器异常，请稍后重试！');
				return;
			});
		} else { //上拉加载
			if(nextUrl == '') {
				refreshBlock.endPullupToRefresh(true);
				return;
			} else {
				refreshBlock.enablePullupToRefresh(); //启用上拉
				refreshBlock.refresh(true); //重置上拉
			}
			c.dataUtil.getListData(HOST_CONFIG + nextUrl, function(res) {
				console.log('【===评论列表 下一页===】' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					nextUrl = res.nextUrl;
					for(var i = 0; i < res.varList.length; i++) {
						res.varList[i].timeStamp = res.varList[i].createDate; //创建第二个时间戳变量，便于区分第一个变量进行操作
						//创建一个时间对象 
						var newDate = new Date(res.varList[i].createDate.replace(/-/g, "/")); //兼容ios
						var month = newDate.getMonth() + 1 + '月';
						var date = newDate.getDate() + '日';
						res.varList[i].createDate = [month, date].join(' ');
					}
					ui.commentContent.innerHTML += template('commentContentTmpl', {
						List: res.varList,
					});
					if(nextUrl == '') {
						refreshBlock.endPullupToRefresh(true);
					} else {
						refreshBlock.endPullupToRefresh(false);
					}
				} else {
					$.toast(ERROR_CONFIG[data.SystemCode]);
					refreshBlock.endPullupToRefresh(true);
					return;
				}
			}, function(xhr, type, err) { //error
				refreshBlock.endPulldown(); //结束下拉
				refreshBlock.disablePullupToRefresh(); //禁用上拉
				$.toast('服务器异常，请稍后重试！');
				return;
			});
		}
	}

	//事件绑定
	function bindEvents() {
		//点击跳转"文章详情"页面
		ui.commentContent.addEventListener('tap', function() {
			c.webviewUtil.show('articleDetail', null, null, null, null);
		})
	}

	return {
		init: function() {
			bindEvents();
		},
		getCommentList: getCommentList
	}

})(window, mui);

/*
 * 说明：我的反馈
 * 时间：2018/3/30/ 13:15
 * 创建：lj
 */
//获取反馈列表
var getFeedBackList = (function(c, $) {
	var nextUrl = ""; //下一页
	var ui = {
		suggestContent: document.getElementById("suggestContent"),
		editBtn: document.getElementById("editBtn"),
	}

	//获取列表数据
	function feedBackList(isRefresh) {
		var refreshBlock = $('#flistBlock').pullRefresh();
		if(isRefresh) { //下拉刷新
			c.dataUtil.getFeedbackList('', function(res) {
				console.log('【===反馈列表===】' + JSON.stringify(res));
				refreshBlock.endPulldown(); //结束下拉	
				if(res.SystemCode == 1) {
					nextUrl = res.nextUrl;
					if(res.varList) {
						ui.suggestContent.innerHTML = template('suggestContentTmpl', {
							List: res.varList,
						});
					} else {
						ui.suggestContent.innerHTML = '<div class="no-data" style="margin-top: 160px;width:100%;height:100%;"><img src="../../assets/images/404/no-data.png" style="width: 200px;height: 150px;"/><div>暂时没有数据</div></div>';
					}

					if(nextUrl == '') { //无下一页数据
						refreshBlock.disablePullupToRefresh(); //禁用上拉
					} else {
						refreshBlock.enablePullupToRefresh(); //启用上拉
						refreshBlock.refresh(true); //重置上拉
					}
				} else {
					$.toast(ERROR_CONFIG[res.SystemCode]);
					refreshBlock.disablePullupToRefresh(); //禁用上拉
					return;
				}
			}, function(xhr, type, err) { //error
				refreshBlock.endPulldown(); //结束下拉
				refreshBlock.disablePullupToRefresh(); //禁用上拉
				$.toast('服务器异常，请稍后重试！');
				return;
			});
		} else { //上拉加载
			if(nextUrl == '') {
				refreshBlock.endPullupToRefresh(true);
				return;
			} else {
				refreshBlock.enablePullupToRefresh(); //启用上拉
				refreshBlock.refresh(true); //重置上拉
			}
			c.dataUtil.getFeedbackList(HOST_CONFIG + nextUrl, function(res) {
				console.log('【===反馈列表 下一页===】' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					nextUrl = res.nextUrl;
					ui.suggestContent.innerHTML += template('suggestContentTmpl', {
						List: res.varList,
					});
					if(nextUrl == '') {
						refreshBlock.endPullupToRefresh(true);
					} else {
						refreshBlock.endPullupToRefresh(false);
					}
				} else {
					$.toast(ERROR_CONFIG[data.SystemCode]);
					refreshBlock.endPullupToRefresh(true);
					return;
				}
			}, function(xhr, type, err) { //error
				refreshBlock.endPulldown(); //结束下拉
				refreshBlock.disablePullupToRefresh(); //禁用上拉
				$.toast('服务器异常，请稍后重试！');
				return;
			});
		}
	}

	//事件绑定
	function bindEvents() {
		//右标跳转"添加评论"下级页面
		ui.editBtn.addEventListener('tap', function() {
			c.webviewUtil.show('feedBack', null, null, null, null);
		})
		//自定义事件 => 刷新列表
		window.addEventListener('addSuccess', function(e) {
			feedBackList(true);
		})
	}

	return {
		init: function() {
			//			plus.nativeUI.showWaiting('加载中...');
			bindEvents();
		},
		feedBackList: feedBackList
	}
})(window, mui);

/*
 * 说明：新增反馈
 * 时间：2018/4/2/ 13:45
 * 创建：lj
 */
//获取新增内容
var addFeedback = (function(c, $) {
	var ui = {
		fContentTxt: document.getElementById("fContentTxt"),
		fbtn: document.getElementById("fbtn"),
	}

	//事件绑定
	function bindEvents() {
		ui.fbtn.addEventListener('tap', function() {

			c.methodUtil.solveSoftKeyboard();

			//传给后台的参数
			var txtVal = ui.fContentTxt.value;
			if(!txtVal.trim()) {
				$.toast("请输入内容");
				return;
			} else if(txtVal.length > 300) {
				$.toast("反馈内容不能超过300字");
				return;
			}
			//验证通过
			$.confirm('是否确认提交', '提示', ['确认', '取消'], function(e) {
				document.activeElement.blur(); //收回软键盘
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.nativeUI.showWaiting('发布中...');
					//传给后台的参数
					console.log(JSON.stringify(txtVal));
					//调取后端新增接口
					c.dataUtil.addFeedback(txtVal, function(res) {
						plus.nativeUI.closeWaiting();
						console.log('===新增反馈===' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							$.toast('提交成功');
							//触发自定义事件
							$.fire(plus.webview.currentWebview().opener(), 'addSuccess', {});
							setTimeout(function() {
								plus.webview.currentWebview().close(); //关闭页面
							})
						} else {
							$.toast(c.ERROR_CONFIG[res.SystemCode]);
						}
					}, function(xhr, type, err) {
						plus.nativeUI.closeWaiting();
						$.toast('提交失败，请稍后重试')
					})

				}
			})
		});
	}
	return {
		init: function() {
			//plus.nativeUI.showWaiting('加载中...');
			bindEvents();
		}
	}
})(window, mui);

/*
 * 说明：修改用户信息
 * 时间：2018/4/23 16:46
 * 创建：ch
 * 
 */
var editUserInfo = (function(c, $) {

	var ui = {
			name: document.getElementById("realName"),
			nickName: document.getElementById("nickName"),
			email: document.getElementById("email"),
			wechat: document.getElementById("wechat"),
			qq: document.getElementById("QQ"),
			content: document.querySelector(".mui-content"),
			done: document.getElementById("done"),
			idNum: document.getElementById("idNum")
		},
		userId;

	var info_arr = ['name', 'nickName', 'email', 'wechat', 'qq', 'idNum'];

	function bindEvents() {
		//点击提交
		ui.done.addEventListener('tap', function() {
			var obj = {};
			obj.userId = userId;
			for(var i = 0; i < info_arr.length; i++) {
				obj[info_arr[i]] = ui[info_arr[i]].value
			}
			if(obj.email != '' && !/^[a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.[a-zA-Z0-9]{2,6}$/.test(obj.email)) {
				$.toast('邮箱格式不正确');
				return;
			}
			if(obj.name == '') {
				$.toast('请输入真实姓名');
				return;
			}
			if(obj.idNum == '') {
				$.toast('请输入身份证号');
				return;
			}
			if(obj.nickName == '') {
				$.toast('请输入昵称');
				return;
			}
			$.confirm('是否确认提交？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					console.log(JSON.stringify(obj));
					plus.nativeUI.showWaiting('提交中...');
					c.dataUtil.saveUserInfo(obj, function(res) {
						plus.nativeUI.closeWaiting();
						console.log('===提交修改===' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							if(obj.nickName != '') {
								$.fire(plus.webview.currentWebview().opener(), 'afterModify', {
									nickName : obj.nickName
								})
							}
							$.toast('提交成功');
						} else {
							$.toast(c.ERROR_CONFIG[res.SystemCode]);
						}
					}, function(xhr, type, err) {
						plus.nativeUI.closeWaiting();
						$.toast('提交失败');
					})
				}
			})
		})
	}

	return {
		init: function() {
			plus.nativeUI.showWaiting('加载中...');
			userId = JSON.parse(plus.storage.getItem('userInfo')).userId;
			c.dataUtil.getUserInfo(userId, function(res) {
				console.log('===用户信息===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					ui.content.style.display = 'block';
					for(var i = 0; i < info_arr.length; i++) {
						if(res.data[info_arr[i]]) {
							ui[info_arr[i]].value = res.data[info_arr[i]];
						} else {
							ui[info_arr[i]].value = '';
						}
						
					}
				}
				plus.nativeUI.closeWaiting();
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				$.toast('获取信息失败，请稍后重试');
			});

			bindEvents();
		}
	}
}(window, mui));


/*
 * 说明：裁剪上传头像
 * 创建：ch
 * 时间：2018/04/24 10:10
 * 
 */
var UploadImg = (function(c) {

	function _getRoundedCanvas(sourceCanvas) {
		var canvas = document.createElement('canvas'),
			context = canvas.getContext('2d'),
			width = sourceCanvas.width,
			height = sourceCanvas.height;
		canvas.width = width;
		canvas.height = height;
		context.beginPath();
		//图片是圆形剪裁之后
		//		context.arc(width / 2, height / 2, Math.min(width, height) / 2, 0, 2 * Math.PI);
		//图片剪裁之后是矩形
		context.rect(width / 100, height / 100, width, height);
		context.strokeStyle = 'rgba(0,0,0,0)';
		context.stroke();
		context.clip();
		context.drawImage(sourceCanvas, 0, 0, width, height);
		return canvas;
	}

	function _cuting() {
		window.addEventListener('path', function(e) {
			var token = event.detail.token;
			var path = event.detail.path;
			document.getElementById('image').src = plus.io.convertLocalFileSystemURL(path);
			var self = plus.webview.currentWebview(),
				opener = self.opener(),
				$image = $('#image'),
				$button = $('#button_ing'),
				croppable = false;
			$image.cropper({
				aspectRatio: 1,
				viewMode: 1,
				ready: function() {
					croppable = true;
				}
			});
			$button.on('click', function() {
				plus.nativeUI.showWaiting('上传中...');
				var croppedCanvas,
					roundedCanvas;
				if(!croppable) {
					return;
				}
				croppedCanvas = $image.cropper('getCroppedCanvas');
				roundedCanvas = _getRoundedCanvas(croppedCanvas);
				var src = roundedCanvas.toDataURL();
				var base64 = src.split(",")[1];
				var format = src.split(';')[0].split('/')[1];
				//表单上传
				var form = new FormData();
				form.append('base64', base64);
				form.append('format', format);
				var task = plus.uploader.createUpload(c.IMAGE_UPLOAD_CONFIG, {
						method: "POST"
					},
					function(t, status) {
						if(status == 200) {
							var result = JSON.parse(t.responseText);
							console.log("success: " + JSON.stringify(result))
							plus.nativeUI.closeWaiting();
							var photoId = result.data[0];
							console.log(photoId)
							var obj = {
								userId: JSON.parse(plus.storage.getItem('userInfo')).userId,
								photo: photoId
							}
							//post发送photoId
							c.dataUtil.saveUserInfo(obj, function(res) {
								console.log("更改头像" + JSON.stringify(res))
								mui.fire(opener, 'cutsrc', {
									photoId: photoId
								});
								mui.toast('图片上传成功');
							}, function(xhr,type,err) {
								console.log('xhr' + xhr.status)
								mui.toast('图片上传失败');
							});
							plus.webview.currentWebview().close();
						} else {
							plus.nativeUI.toast('图片上传失败');
							console.log("Upload failed: " + status);
						}
					}
				);
				task.addFile(path, {
					key: "files"
				});
				task.addData('form', form)
				task.start();
			});

		});

	}
	return {
		init: function() {
			_cuting();
		}
	};
}(window));